set tfprttWidth 128
set tfprttHeight 128
set tfprttSupersample 0
set tfprttRendermode 0
set tfprttNormalMapMode 0
set tfprttPerObjectTextures 0
set tfprttCombineResult 0

proc tfprendertotexture_dialog {} {
   global tfprttWidth tfprttHeight tfprttSupersample tfprttRendermode tfprttNormalMapMode tfprttPerObjectTextures tfprttCombineResult

   if ![winfo exists .rendertotexture] {
      toplevel .rendertotexture
      wm title .rendertotexture "Render to Texture"
      wm transient .rendertotexture [winfo toplevel [winfo parent .rendertotexture]]

      frame .rendertotexture.f1
      pack .rendertotexture.f1 -side top -fill x

      label .rendertotexture.f1.titleX -text "Texture Width:" -width 15 -anchor e -padx 5      
      pack .rendertotexture.f1.titleX -side left -fill x -expand 1

      entry .rendertotexture.f1.enterX -textvariable tfprttWidth -relief sunken -width 40
      pack .rendertotexture.f1.enterX -side left -fill x -expand 1


      frame .rendertotexture.f2
      pack .rendertotexture.f2 -side top -fill x

      label .rendertotexture.f2.titleY -text "Texture Height:" -width 15 -anchor e -padx 5      
      pack .rendertotexture.f2.titleY -side left -fill x -expand 1

      entry .rendertotexture.f2.enterY -textvariable tfprttHeight -relief sunken -width 40
      pack .rendertotexture.f2.enterY -side left -fill x -expand 1


      frame .rendertotexture.f3
      pack .rendertotexture.f3 -side top -fill x

      label .rendertotexture.f3.titleZ -text "Super Sampling:" -width 15 -anchor e -padx 5
      pack .rendertotexture.f3.titleZ -side left -fill x -expand 1

      entry .rendertotexture.f3.enterZ -textvariable tfprttSupersample -relief sunken -width 40
      pack .rendertotexture.f3.enterZ -side left -fill x -expand 1


      frame .rendertotexture.f4
      pack .rendertotexture.f4 -side top -fill x

      label .rendertotexture.f4.titlePer -text "Multiple Textures:" -width 8 -anchor e -padx 5
      pack .rendertotexture.f4.titlePer -side left -fill x -expand 1 -anchor nw

      checkbutton .rendertotexture.f4.enterPerObjectTextures -text "Append Object Name to Texture Name" -variable tfprttPerObjectTextures -width 30 -anchor w
      pack .rendertotexture.f4.enterPerObjectTextures -side left -fill x -expand 1 
      
      
      frame .rendertotexture.f7
      pack .rendertotexture.f7 -side top -fill x

      label .rendertotexture.f7.titlePer -text "Baking:" -width 8 -anchor e -padx 5
      pack .rendertotexture.f7.titlePer -side left -fill x -expand 1 -anchor nw

      checkbutton .rendertotexture.f7.enterCombineResults -text "Multiply Current Texture with Output Result" -variable tfprttCombineResult -width 30 -anchor w
      pack .rendertotexture.f7.enterCombineResults -side left -fill x -expand 1 

      

      frame .rendertotexture.f5
      pack .rendertotexture.f5 -side top -fill x

      label .rendertotexture.f5.titleMode -text "Input Normal Maps:" -width 18 -anchor e -padx 5            
      pack .rendertotexture.f5.titleMode -side left -fill x -expand 1 -anchor nw

      radiobutton .rendertotexture.f5.enterInputTextureNormalsObject -text "Object Space" -variable tfprttNormalMapMode -value 1 -width 40 -anchor w
      pack .rendertotexture.f5.enterInputTextureNormalsObject -side top -fill x -expand 1 

      radiobutton .rendertotexture.f5.enterInputTextureNormalsTangent -text "Tangent Space" -variable tfprttNormalMapMode -value 2 -width 40 -anchor w
      pack .rendertotexture.f5.enterInputTextureNormalsTangent -side top -fill x -expand 1 
                  
      radiobutton .rendertotexture.f5.enterInputTextureNone -text "None" -variable tfprttNormalMapMode -value 0 -width 40 -anchor w
      pack .rendertotexture.f5.enterInputTextureNone -side top -fill x -expand 1


      frame .rendertotexture.f6
      pack .rendertotexture.f6 -side top -fill x

      label .rendertotexture.f6.titleMode -text "" -width 18 -anchor w -padx 5            
      pack .rendertotexture.f6.titleMode -side left -fill x -expand 1 -anchor nw



      frame .rendertotexture.f9
      pack .rendertotexture.f9 -side top -fill x

      label .rendertotexture.f9.titleMode -text "Render:" -width 18 -anchor e -padx 5            
      pack .rendertotexture.f9.titleMode -side left -fill x -expand 1 -anchor nw
      
      radiobutton .rendertotexture.f9.enterModeLighting -text "Lights and Shadows (includes AO)" -variable tfprttRendermode -value 0 -width 40 -anchor w
      pack .rendertotexture.f9.enterModeLighting -side top -fill x -expand 1 

      radiobutton .rendertotexture.f9.enterModeAmbientOcclusion -text "Ambient Occlusion (mask)" -variable tfprttRendermode -value 5 -width 40 -anchor w
      pack .rendertotexture.f9.enterModeAmbientOcclusion -side top -fill x -expand 1 
                  
      radiobutton .rendertotexture.f9.enterModeObjectNormals -text "Object Space Normals" -variable tfprttRendermode -value 2 -width 40 -anchor w
      pack .rendertotexture.f9.enterModeObjectNormals -side top -fill x -expand 1
            
      radiobutton .rendertotexture.f9.enterModeTangentNormals -text "Tangent Space Normals from Object Space Map" -variable tfprttRendermode -value 4 -width 40 -anchor w
      pack .rendertotexture.f9.enterModeTangentNormals -side top -fill x -expand 1
      
      radiobutton .rendertotexture.f9.enterModeTangentCrease -text "Tangent Space Normals from Crease Angle" -variable tfprttRendermode -value 3 -width 40 -anchor w
      pack .rendertotexture.f9.enterModeTangentCrease -side top -fill x -expand 1
            
      radiobutton .rendertotexture.f9.enterModeDisplacement -text "3D Displacement in Local Space (Sculpt Map)" -variable tfprttRendermode -value 1 -width 40 -anchor w
      pack .rendertotexture.f9.enterModeDisplacement -side top -fill x -expand 1

      radiobutton .rendertotexture.f9.enterModeBurnMaterials -text "Material Colors" -variable tfprttRendermode -value 6 -width 40 -anchor w
      pack .rendertotexture.f9.enterModeBurnMaterials -side top -fill x -expand 1      
		
      frame .rendertotexture.f99
      pack .rendertotexture.f99 -side bottom -fill x

      button .rendertotexture.f99.ok -text "Render" -command {
		 wm withdraw .rendertotexture
         eval ac3d tfprtt_rendertotexture 0 $tfprttWidth $tfprttHeight $tfprttSupersample $tfprttRendermode $tfprttNormalMapMode $tfprttPerObjectTextures $tfprttCombineResult 0 0 0 0 0 0 0
         eval ac3d redraw_all
      }
      pack .rendertotexture.f99.ok -side left -fill x -expand 1

      button .rendertotexture.f99.cancel -text "Close" -command {
         wm withdraw .rendertotexture
      }
      pack .rendertotexture.f99.cancel -side left -fill x -expand 1
   }

   wm deiconify .rendertotexture
   centre_window_on_screen .rendertotexture
}
